# -*- coding: utf-8 -*- 
# ##############################################################################
# 					    *** Librairie de fonction pour Activator ***
# ##############################################################################

# Configuration
Activator=0
#ActivatorPort="COM7"
ActivatorPort="Serial1"
BoardTypeActivator="atmega328" # atmega168 | atmega328 | atmega328p | atmega2560 | atmega1280 | atmega32u4
defaultRingColor="bleu"
WatchDog=1  # mettre 0 si on ne veux pas du watchdog

# ##############################################################################
# Variables globales
# ##############################################################################
BatteryElectValue=0
BatteryMotorValue=0
AudioVolume=30
RobotReadyForAction=0
BatteryElectValueRounded=0
BatteryMotorValueRounded=0

# ##############################################################################
# Activator arduino configuration
# ##############################################################################
if Activator==1:
	ActivatorArduino = Runtime.createAndStart("ActivatorArduino","Arduino")
	ActivatorArduino.setBoard(BoardTypeActivator)
	
	if ActivatorPort=="Serial1":
		ActivatorArduino.connect(left,ActivatorPort)
	else:
		ActivatorArduino.connect(ActivatorPort)
		
	ActivatorArduino.enableBoardInfo(False)
	sleep(0.5)
	ActivatorArduino.addListener("publishCustomMsg","python","receiveActivatorData")

# ##############################################################################
# Fonction de réception de données
# ##############################################################################
def receiveActivatorData(data):
	global BatteryElectValue
	global BatteryMotorValue
	global AudioVolume
	global BatteryElectValueRounded
	global BatteryMotorValueRounded
	
	BatteryElectValue=(data[0]*256)+data[1]
	BatteryMotorValue=(data[2]*256)+data[3]
	AudioVolume=data[4]
	pulseTime=data[5]
	
	if DEBUG==1:
		print "Bat1=",BatteryElectValue," Bat2=",BatteryMotorValue," Volume=",AudioVolume," Pulse time=",pulseTime
		
	BatteryElectValueRounded=int(round((int(BatteryElectValue)/1000)))
	BatteryMotorValueRounded=int(round((int(BatteryMotorValue)/1000)))
	#chatBot.setPredicate("default","BatteryElectValue",str(BatteryElectValue))
	#chatBot.setPredicate("default","BatteryMotorValue",str(BatteryMotorValue))
	#chatBot.setPredicate("default","BatteryElectValueRounded",str(BatteryElectValueRounded))
	#chatBot.setPredicate("default","BatteryMotorValueRounded",str(BatteryMotorValueRounded))
	#print BatteryElectValueRounded," ",BatteryMotorValueRounded
    
# ##############################################################################
# Demande la mise à jour des valeurs batteries et audio
# ##############################################################################
def updateDataRequest():
	if Activator==1:
		ActivatorArduino.customMsg(1)

# ##############################################################################
# Commande à envoyer quand le PC a terminé de charger tout les services
# Attention, le watchdog est automatiquement activé.
# ##############################################################################
def pcIsReady():
	if Activator==1:
		ActivatorArduino.digitalWrite(2,1)
		sleep(0.1)
		print "InMoov is ready"

# ##############################################################################
# Commande à envoyer quand on veut endormir InMoov
# ##############################################################################
def shudownRequest():
	if Activator==1:
		ActivatorArduino.digitalWrite(3,1)
		sleep(0.1)
		print "Shudown enable"
    
# ##############################################################################
# Commande à envoyer périodiquement pour le watchdog  
# ##############################################################################
def watchdogRefresh():
	if Activator==1:
		ActivatorArduino.digitalWrite(4,1)

# ##############################################################################
# Permet de désactiver le watchdog
# pour debug par exemple
# ##############################################################################
def disableWatchdog():
	if Activator==1:
		ActivatorArduino.digitalWrite(4,0)
		sleep(0.1)
		print "Watchdog disable"

# ##############################################################################
# Permet d'activer l'alimentation des servos
# ##############################################################################
def powerServoON():
	if Activator==1:
		ActivatorArduino.digitalWrite(5,1)
		sleep(0.1)
		print "Servo power enable"

# ##############################################################################
# Permet d'éteindre l'alimentation des servos
# ##############################################################################
def powerServoOFF():
	if Activator==1:
		ActivatorArduino.digitalWrite(5,0)
		sleep(0.1)
		print "Servo power disable"

# ##############################################################################
# Commande machoire : JawBlock()
# Désactive les mouvements avec l'audio
# ##############################################################################
def JawBlock():
	if Activator==1:
		ActivatorArduino.digitalWrite(6,1)
		sleep(0.1)
		print "Jaw is blocked"

# ##############################################################################
# Commande machoire : JawDeBlock()
# Active les mouvements avec l'audio (par défaut)
# ##############################################################################
def JawDeBlock():
	if Activator==1:
		ActivatorArduino.digitalWrite(6,0)
		sleep(0.1)
		print "Jaw is enable"

# ##############################################################################
# Commande machoire : JawAction(action)
# action = "ouvre"
# action = "ferme"
# ##############################################################################
def JawAction(action):
	if Activator==1 and RobotReadyForAction==1:
		if action=="ouvre":
			ActivatorArduino.digitalWrite(7,1)
			print "Jaw is opened"
		else:
			ActivatorArduino.digitalWrite(7,0)
			print "Jaw is closed"
		sleep(0.1)

# ##############################################################################
# Commande machoire : JawDetach()
# Coupe le signal PWM sur le servo JAW
# ##############################################################################
def JawDetach():
	if Activator==1:
		ActivatorArduino.digitalWrite(19,1)
		sleep(0.1)
		print "Servo Jaw is dettach"

# ##############################################################################
# NeoPixelColor("rouge")
# ##############################################################################
def NeoPixelColor(action):
	if Activator==1:
		# Couleur intensité normal
		if action=="noir":
			ActivatorArduino.digitalWrite(20,0)
		elif action=="jaune":
			ActivatorArduino.digitalWrite(20,1)
		elif action=="rouge":
			ActivatorArduino.digitalWrite(21,1)
		elif action=="bleu":
			ActivatorArduino.digitalWrite(22,1)
		elif action=="vert":
			ActivatorArduino.digitalWrite(23,1)
		elif action=="Cyan":
			ActivatorArduino.digitalWrite(24,1)
		elif action=="rose":
			ActivatorArduino.digitalWrite(25,1)
		elif action=="blanc":
			ActivatorArduino.digitalWrite(26,1)
		# Couleur basse intensité
		elif action=="jaune_bl":
			ActivatorArduino.digitalWrite(30,1)
		elif action=="rouge_bl":
			ActivatorArduino.digitalWrite(31,1)
		elif action=="bleu_bl":
			ActivatorArduino.digitalWrite(32,1)
		elif action=="vert_bl":
			ActivatorArduino.digitalWrite(33,1)
		elif action=="Cyan_bl":
			ActivatorArduino.digitalWrite(34,1)
		elif action=="rose_bl":
			ActivatorArduino.digitalWrite(35,1)
		elif action=="blanc_bl":
			ActivatorArduino.digitalWrite(36,1)
		# Couleur haute intensité
		elif action=="jaune_hl":
			ActivatorArduino.digitalWrite(40,1)
		elif action=="rouge_hl":
			ActivatorArduino.digitalWrite(41,1)
		elif action=="bleu_hl":
			ActivatorArduino.digitalWrite(42,1)
		elif action=="vert_hl":
			ActivatorArduino.digitalWrite(43,1)
		elif action=="Cyan_hl":
			ActivatorArduino.digitalWrite(44,1)
		elif action=="rose_hl":
			ActivatorArduino.digitalWrite(45,1)
		elif action=="blanc_hl":
			ActivatorArduino.digitalWrite(46,1)
		sleep(0.1)
    
# ##############################################################################
# NeoPixelCustomColor(100,200,50)
# ##############################################################################
def NeoPixelCustomColor(r, g, b):
	if Activator==1:
		ActivatorArduino.customMsg(2,r,g,b)
		sleep(0.1)
    
# ##############################################################################
# Clignotement du neo pixel avec la dernière
# couleur active (1 ou 0)
# ##############################################################################
def ringBlink(action):
	if Activator==1:
		if action==1:
			ActivatorArduino.digitalWrite(8,1)
		else:
			ActivatorArduino.digitalWrite(8,0)
		sleep(0.1)

# ##############################################################################
# NeoPixelAnimation(action)
# Action = 0, 1, 2, 3
# ##############################################################################
def NeoPixelAnimation(action):
	if Activator==1:
		if action==0:
			ActivatorArduino.digitalWrite(10,0)
		elif action==1:
			ActivatorArduino.digitalWrite(10,1)
		elif action==2:
			ActivatorArduino.digitalWrite(11,1)
		elif action==3:
			ActivatorArduino.digitalWrite(14,1)
		sleep(0.1)

# ##############################################################################
# NeoPixelPulseAnimation(action)
# animation pendant une duree défini
# Action = 1, 2 ou 3
# ##############################################################################
def NeoPixelPulseAnimation(action):
	if Activator==1:
		if action==1:
			ActivatorArduino.digitalWrite(12,1)
		elif action==2:
			ActivatorArduino.digitalWrite(12,0)
		elif action==3:
			ActivatorArduino.digitalWrite(13,1)
		sleep(0.1)

# ##############################################################################
# NeoPixelPulseTime(time)
# Régle la durée des pulses animations(unités 0.5s)
# ##############################################################################
def NeoPixelPulseTime(time):
	if Activator==1:
		ActivatorArduino.customMsg(3,time)
		sleep(0.1)

# ##############################################################################
# Règle le volume audio SoundControl(30)
# Volume audio de 0 à 63
# ##############################################################################
def SoundControl(action):
	if Activator==1:
		if action <= 63:
			ActivatorArduino.analogWrite(0,action)
		sleep(0.1)
    
# ##############################################################################
# Fonction SoundMute()
# ##############################################################################
def SoundMute():
	if Activator==1:
		ActivatorArduino.digitalWrite(17,1)
		sleep(0.1)

# ##############################################################################
# Fonction SoundMuteOff()
# ##############################################################################
def SoundMuteOff():
	if Activator==1:
		ActivatorArduino.digitalWrite(17,0)
		sleep(0.1)

# ##############################################################################
# Fonction SoundDisable()
# ##############################################################################
def SoundDisable():
	if Activator==1:
		ActivatorArduino.digitalWrite(18,1)
		sleep(0.1)

# ##############################################################################
# Fonction SoundEnable()
# ##############################################################################
def SoundEnable():
	if Activator==1:
		ActivatorArduino.digitalWrite(18,0)
		sleep(0.1)

