# -*- coding: utf-8 -*- 
# ##############################################################################
# 					    *** Librairie de fonction pour Activator ***
# ##############################################################################

# Configuration
Activator=1
#ActivatorPort="COM4"
ActivatorPort="Serial1"
BoardTypeActivator="atmega328" # atmega168 | atmega328 | atmega328p | atmega2560 | atmega1280 | atmega32u4
defaultRingColor="bleu"
WatchDog=1  # mettre 0 si on ne veux pas du watchdog

# ##############################################################################
# Variables globales
# ##############################################################################
BatteryElectValue=0
BatteryMotorValue=0
AudioVolume=30
RobotReadyForAction=0
BatteryElectValueRounded=0
BatteryMotorValueRounded=0

# ##############################################################################
# Activator arduino configuration
# ##############################################################################
if Activator==1:
	ActivatorArduino = Runtime.createAndStart("ActivatorArduino","Arduino")
	ActivatorArduino.setBoard(BoardTypeActivator)
	
	if ActivatorPort=="Serial1":
		if megaBoardIsOK==1:
			ActivatorArduino.connect(MegaBoard,ActivatorPort)
		else:
			ActivatorArduino.connect(left,ActivatorPort)
	else:
		ActivatorArduino.connect(ActivatorPort)
		
	ActivatorArduino.enableBoardInfo(False)
	sleep(0.5)
	ActivatorArduino.addListener("publishCustomMsg","python","receiveActivatorData")

# ##############################################################################
# Fonction de réception de données
# ##############################################################################
def receiveActivatorData(data):
	global BatteryElectValue
	global BatteryMotorValue
	global AudioVolume
	global BatteryElectValueRounded
	global BatteryMotorValueRounded

	if data[0]==1:
		if data[1]==0:
			print "Activator version: ",data[2],".",data[3]
		elif data[1]==4:
			print "Servo power ON"
		elif data[1]==5:
			print "Servo power OFF"
	elif data[0]==4:
		if data[1]==4:
			if data[2]==255:
				print "MAX9744 error..."
			else:
				print "Volume audio: ",data[2]
	elif data[0]==5:
		BatteryElectValue=(data[1]*256)+data[2]
		BatteryMotorValue=(data[3]*256)+data[4]
		AudioVolume=data[5]
		pulseTime=data[6]
		
		if DEBUG==1:
			print "Bat1=",BatteryElectValue," Bat2=",BatteryMotorValue," Volume=",AudioVolume," Pulse time=",pulseTime
			
		BatteryElectValueRounded=int(round((int(BatteryElectValue)/1000)))
		BatteryMotorValueRounded=int(round((int(BatteryMotorValue)/1000)))
		#chatBot.setPredicate("default","BatteryElectValue",str(BatteryElectValue))
		#chatBot.setPredicate("default","BatteryMotorValue",str(BatteryMotorValue))
		#chatBot.setPredicate("default","BatteryElectValueRounded",str(BatteryElectValueRounded))
		#chatBot.setPredicate("default","BatteryMotorValueRounded",str(BatteryMotorValueRounded))
		#print BatteryElectValueRounded," ",BatteryMotorValueRounded
    
# ##############################################################################
# Demande la mise à jour des valeurs batteries et audio
# ##############################################################################
def updateDataRequest():
	if Activator==1:
		ActivatorArduino.customMsg(5)

# ##############################################################################
# Commande à envoyer quand le PC a terminé de charger tout les services
# Attention, le watchdog est automatiquement activé.
# ##############################################################################
def pcIsReady():
	if Activator==1:
		ActivatorArduino.customMsg(1,0)
		sleep(0.1)
		print "InMoov is ready"

# ##############################################################################
# Commande à envoyer quand on veut endormir InMoov
# ##############################################################################
def shudownRequest():
	if Activator==1:
		ActivatorArduino.customMsg(1,1)
		sleep(0.1)
		print "Shudown enable"
    
# ##############################################################################
# Commande à envoyer périodiquement pour le watchdog  
# ##############################################################################
def watchdogRefresh():
	if Activator==1:
		ActivatorArduino.customMsg(1,2)

# ##############################################################################
# Permet de désactiver le watchdog
# pour debug par exemple
# ##############################################################################
def disableWatchdog():
	if Activator==1:
		ActivatorArduino.customMsg(1,3)
		sleep(0.1)
		print "Watchdog disable"

# ##############################################################################
# Permet d'activer l'alimentation des servos
# ##############################################################################
def powerServoON():
	if Activator==1:
		ActivatorArduino.customMsg(1,4)
		sleep(0.1)

# ##############################################################################
# Permet d'éteindre l'alimentation des servos
# ##############################################################################
def powerServoOFF():
	if Activator==1:
		ActivatorArduino.customMsg(1,5)
		sleep(0.1)

# ##############################################################################
# Commande machoire : JawBlock()
# Désactive les mouvements avec l'audio
# ##############################################################################
def JawBlock():
	if Activator==1:
		ActivatorArduino.customMsg(2,0)
		sleep(0.1)
		print "Jaw is blocked"

# ##############################################################################
# Commande machoire : JawDeBlock()
# Active les mouvements avec l'audio (par défaut)
# ##############################################################################
def JawDeBlock():
	if Activator==1:
		ActivatorArduino.customMsg(2,1)
		sleep(0.1)
		print "Jaw is enable"

# ##############################################################################
# Commande machoire : JawAction(action)
# action = "ouvre"
# action = "ferme"
# ##############################################################################
def JawAction(action):
	if Activator==1 and RobotReadyForAction==1:
		if action=="ouvre":
			ActivatorArduino.customMsg(2,2)
			print "Jaw is opened"
		else:
			ActivatorArduino.customMsg(2,3)
			print "Jaw is closed"
		sleep(0.1)

# ##############################################################################
# Commande machoire : JawDetach()
# Coupe le signal PWM sur le servo JAW
# ##############################################################################
def JawDetach():
	if Activator==1:
		ActivatorArduino.customMsg(2,4)
		sleep(0.1)
		print "Servo Jaw is dettach"

# ##############################################################################
# NeoPixelColor("rouge")
# ##############################################################################
def NeoPixelColor(action):
	if Activator==1:
		# Couleur intensité normal
		if action=="noir":
			ActivatorArduino.customMsg(3,2)
		elif action=="jaune":
			ActivatorArduino.customMsg(3,3)
		elif action=="rouge":
			ActivatorArduino.customMsg(3,4)
		elif action=="vert":
			ActivatorArduino.customMsg(3,5)
		elif action=="bleu":
			ActivatorArduino.customMsg(3,6)
		elif action=="Cyan":
			ActivatorArduino.customMsg(3,7)
		elif action=="rose":
			ActivatorArduino.customMsg(3,8)
		elif action=="blanc":
			ActivatorArduino.customMsg(3,9)
		# Couleur basse intensité
		elif action=="jaune_bl":
			ActivatorArduino.customMsg(3,12)
		elif action=="rouge_bl":
			ActivatorArduino.customMsg(3,13)
		elif action=="vert_bl":
			ActivatorArduino.customMsg(3,14)
		elif action=="bleu_bl":
			ActivatorArduino.customMsg(3,15)
		elif action=="Cyan_bl":
			ActivatorArduino.customMsg(3,16)
		elif action=="rose_bl":
			ActivatorArduino.customMsg(3,17)
		elif action=="blanc_bl":
			ActivatorArduino.customMsg(3,18)
		# Couleur haute intensité
		elif action=="jaune_hl":
			ActivatorArduino.customMsg(3,19)
		elif action=="rouge_hl":
			ActivatorArduino.customMsg(3,20)
		elif action=="vert_hl":
			ActivatorArduino.customMsg(3,21)
		elif action=="bleu_hl":
			ActivatorArduino.customMsg(3,22)
		elif action=="Cyan_hl":
			ActivatorArduino.customMsg(3,23)
		elif action=="rose_hl":
			ActivatorArduino.customMsg(3,24)
		elif action=="blanc_hl":
			ActivatorArduino.customMsg(3,25)
		sleep(0.1)
    
# ##############################################################################
# NeoPixelCustomColor(100,200,50)
# ##############################################################################
def NeoPixelCustomColor(r, g, b):
	if Activator==1:
		ActivatorArduino.customMsg(3,10,r,g,b)
		sleep(0.1)
    
# ##############################################################################
# Clignotement du neo pixel avec la dernière
# couleur active (1 ou 0)
# ##############################################################################
def ringBlink(action):
	if Activator==1:
		if action==1:
			ActivatorArduino.customMsg(3,4)
		else:
			ActivatorArduino.customMsg(3,0)
		sleep(0.1)

# ##############################################################################
# NeoPixelAnimation(action)
# Action = 0, 1, 2, 3
# ##############################################################################
def NeoPixelAnimation(action):
	if Activator==1:
		if action>=0 and action <=3:
			ActivatorArduino.customMsg(3,0,action)
		sleep(0.1)

# ##############################################################################
# NeoPixelPulseAnimation(action)
# animation pendant une duree défini
# Action = 1, 2 ou 3
# ##############################################################################
def NeoPixelPulseAnimation(action):
	if Activator==1:
		if action>=1 and action <=3:
			ActivatorArduino.customMsg(3,1,action)
		sleep(0.1)

# ##############################################################################
# NeoPixelPulseTime(time)
# Régle la durée des pulses animations(unités 0.5s)
# ##############################################################################
def NeoPixelPulseTime(time):
	if Activator==1:
		ActivatorArduino.customMsg(3,11,time)
		sleep(0.1)

# ##############################################################################
# Règle le volume audio SoundControl(30)
# Volume audio de 0 à 63
# ##############################################################################
def SoundControl(action):
	if Activator==1:
		if action <= 63:
			ActivatorArduino.customMsg(4,4,action)
			sleep(0.1)
    
# ##############################################################################
# Fonction SoundMute()
# ##############################################################################
def SoundMute():
	if Activator==1:
		ActivatorArduino.customMsg(4,0)
		sleep(0.1)

# ##############################################################################
# Fonction SoundMuteOff()
# ##############################################################################
def SoundMuteOff():
	if Activator==1:
		ActivatorArduino.customMsg(4,1)
		sleep(0.1)

# ##############################################################################
# Fonction SoundDisable()
# ##############################################################################
def SoundDisable():
	if Activator==1:
		ActivatorArduino.customMsg(4,2)
		sleep(0.1)

# ##############################################################################
# Fonction SoundEnable()
# ##############################################################################
def SoundEnable():
	if Activator==1:
		ActivatorArduino.customMsg(4,3)
		sleep(0.1)

