# -- coding: utf-8 --
# ##############################################################################
# 							    *** Initialisation hardware ***
# ##############################################################################

# ##############################################################################
# Service MRL InMoov
# ##############################################################################
i01 = Runtime.createAndStart("i01", "InMoov")
i01.setMute(False)
#i01.setMute(1)

# Start the arduinos
# ##############################################################################
if ArduinoMegas==1:

	# Left arduino
	# ##############################################################################
	left = Runtime.create("i01.left", "Arduino")
	left.setBoard(BoardTypeLeft)

	# ##############################################################################
	leftArm = Runtime.create("i01.leftArm", "InMoovArm")

	leftArm.bicep.map(0,180,BicepsLeftMIN,BicepsLeftMAX)
	leftArm.bicep.setRest(0)

	leftArm.shoulder.map(0,180,ShoulderLeftMIN,ShoulderLeftMAX)
	leftArm.shoulder.setRest(0)

	# ##############################################################################
	head = Runtime.create("i01.head", "InMoovHead")

	head.eyeX.map(0,180,EyeXMIN,EyeXMAX)
	head.eyeX.setRest(EyeXRest)

	head.eyeY.map(0,180,EyeYMIN,EyeYMAX)
	head.eyeY.setRest(EyeYRest)

	if NeckInverted==1: 
		head.neck.map(0,180,MaxNeck,MinNeck)
	else:
		head.neck.map(0,180,MinNeck,MaxNeck)
	head.neck.setRest(NeckRest)

	if RotHeadInverted==1: 
		head.rothead.map(0,180,MaxRotHead,MinRotHead)
	else:
		head.rothead.map(0,180,MinRotHead,MaxRotHead)
	head.rothead.setRest(RotHeadRest)

	# Right arduino
	# ##############################################################################
	right=Runtime.create("i01.right", "Arduino")
	right.setBoard(BoardTypeRight)

	# ##############################################################################
	rightArm = Runtime.create("i01.rightArm", "InMoovArm")

	rightArm.bicep.map(0,180,BicepsRightMIN,BicepsRightMAX)
	rightArm.bicep.setRest(0)

	rightArm.shoulder.map(0,180,ShoulderRightMIN,ShoulderRightMAX)
	rightArm.shoulder.setRest(0)

	# ##############################################################################
	torso = Runtime.create("i01.torso", "InMoovTorso")

	torso.topStom.map(0,180,TorsoTopMin,TorsoTopMax)
	torso.topStom.setRest(TorsoTopRest)

	torso.midStom.map(0,180,TorsoMidMin,TorsoMidMax)
	torso.midStom.setRest(TorsoMidRes)

	# ##############################################################################
	left = Runtime.start("i01.left", "Arduino")
	head = Runtime.start("i01.head", "Arduino")
  
	head.setSpeed(DefaultSpeed,DefaultSpeed,DefaultSpeed,DefaultSpeed,DefaultSpeed)
	head.rothead.setSpeed(RotHeadSpeed)
	head.neck.setSpeed(NeckSpeed)
	head.eyeX.setSpeed(EyesSpeed)
	head.eyeY.setSpeed(EyesSpeed)
	head.eyeY.rest()
	head.eyeX.rest()
	
	i01.startHead(leftPort)

	i01.startEyesTracking(leftPort, eyeXPin, eyeYPin)
	i01.startHeadTracking(leftPort)

	i01.eyesTracking.pid.setPID("eyeX",12.0,1.0,0.1)
	i01.eyesTracking.pid.setPID("eyeY",12.0,1.0,0.1)
	i01.headTracking.pid.setPID("rothead",5.0,1.0,0.1)
	i01.headTracking.pid.setPID("neck",5.0,1.0,0.1)

	#i01.eyesTracking.pid.setPID("eyeX",20.0,5.0,0.1)
	#i01.eyesTracking.pid.setPID("eyeY",20.0,5.0,0.1)
	#i01.headTracking.pid.setPID("rothead",12.0,5.0,0.1)
	#i01.headTracking.pid.setPID("neck",12.0,5.0,0.1)
	
	head.neck.setSpeed(NeckSpeed)
	
	i01.startLeftArm(leftPort)
	
	if TorsoArduino=="left":	
		torso = i01.startTorso(leftPort)
	else:
		torso = i01.startTorso(rightPort)
	
	right = Runtime.start("i01.right", "Arduino")
  
	i01.startRightArm(rightPort)
	
  # gestion des mouvement latéraux de la tete ( mod pistons de Bob )
	HeadSide = Runtime.create("HeadSide","Servo")
	HeadSide.map(0,180,MinHeadSide,MaxHeadSide)
	HeadSide.setRest(HeadSideRest)
	HeadSide.setSpeed(HeadSideSpeed)
	HeadSide.attach(right, HeadSidePin, HeadSideRest, 500)

  

  
