# -- coding: utf-8 --
# ##############################################################################

# Configuration
# Ne pas oublier de mettre ArduinoMegas=1
manipulatorLeftIsOk=0
manipulatorLeftComPort = "Serial2"
manipulatorRightIsOk=0
manipulatorRightComPort = "COM16"
#manipulatorRightComPort = "Serial3"
BoardTypeManipulator="atmega328" # atmega168 | atmega328 | atmega328p | atmega2560 | atmega1280 | atmega32u4
ManipulatorSpeed=0.9

# ##############################################################################
# Manipulator arduino configuration
# ##############################################################################
if ArduinoMegas==1:
	if manipulatorLeftIsOk==1:
		manipulatorLeft = Runtime.createAndStart("manipulatorLeft","Arduino")
		manipulatorLeft.setBoard(BoardTypeManipulator)
		#manipulatorLeft.connect(manipulatorLeftComPort)
		manipulatorLeft.connect(left,manipulatorLeftComPort)
		#manipulatorLeft.connect(manipulatorLeftComPort,115200,8,1,0)
		sleep(1)
		manipulatorLeft.publishState()
		
		# Pouce gauche
		thumbLeft = Runtime.createAndStart("thumbLeft","Servo")
		thumbLeft.map(0,180,ThumbLeftMIN,ThumbLeftMAX) 
		thumbLeft.attach(manipulatorLeft,thumbPin)
		thumbLeft.setSpeed(ManipulatorSpeed)
		thumbLeft.setRest(ThumbLeftMIN)
		# Index gauche
		indexLeft = Runtime.createAndStart("indexLeft","Servo")
		indexLeft.map(0,180,IndexLeftMIN,IndexLeftMAX) 
		indexLeft.attach(manipulatorLeft,indexPin)
		indexLeft.setSpeed(ManipulatorSpeed)
		indexLeft.setRest(IndexLeftMIN)
		# Majeur gauche
		majeureLeft = Runtime.createAndStart("majeureLeft","Servo")
		majeureLeft.map(0,180,majeureLeftMIN,majeureLeftMAX) 
		majeureLeft.attach(manipulatorLeft,majeurePin)
		majeureLeft.setSpeed(ManipulatorSpeed)
		majeureLeft.setRest(majeureLeftMIN)
		# Annulaire gauche
		ringFingerLeft = Runtime.createAndStart("ringFingerLeft","Servo")
		ringFingerLeft.map(0,180,ringFingerLeftMIN,ringFingerLeftMAX) 
		ringFingerLeft.attach(manipulatorLeft,ringFingerPin)
		ringFingerLeft.setSpeed(ManipulatorSpeed)
		ringFingerLeft.setRest(ringFingerLeftMIN)
		# Auriculaire gauche
		pinkyLeft = Runtime.createAndStart("pinkyLeft","Servo")
		pinkyLeft.map(0,180,pinkyLeftMIN,pinkyLeftMAX) 
		pinkyLeft.attach(manipulatorLeft,pinkyPin)
		pinkyLeft.setSpeed(ManipulatorSpeed)
		pinkyLeft.setRest(pinkyLeftMIN)
		# Poignée gauche
		wristLeft = Runtime.createAndStart("wristLeft","Servo")
		wristLeft.map(0,180,WristLeftMIN,WristLeftMAX) 
		wristLeft.attach(manipulatorLeft,wristPin)
		wristLeft.setSpeed(ManipulatorSpeed)
		wristLeft.setRest(90)
	else:
		leftHand = Runtime.create("i01.leftHand", "InMoovHand")
		######################################################################
		leftHand.thumb.map(0,180,ThumbLeftMIN,ThumbLeftMAX) 
		leftHand.index.map(0,180,IndexLeftMIN,IndexLeftMAX) 
		leftHand.majeure.map(0,180,majeureLeftMIN,majeureLeftMAX) 
		leftHand.ringFinger.map(0,180,ringFingerLeftMIN,ringFingerLeftMAX) 
		leftHand.pinky.map(0,180,pinkyLeftMIN,pinkyLeftMAX)
		leftHand.wrist.map(0,180,WristLeftMIN,WristLeftMAX)
		i01.startLeftHand(leftPort)

if ArduinoMegas==1:
	if manipulatorRightIsOk==1:
		manipulatorRight = Runtime.createAndStart("manipulatorRight","Arduino")
		manipulatorRight.setBoard(BoardTypeManipulator)
		manipulatorRight.connect(manipulatorRightComPort)
		sleep(1)
		manipulatorRight.publishState()

		# Pouce droit
		thumbRight = Runtime.createAndStart("thumbRight","Servo")
		thumbRight.map(0,180,ThumbRightMIN,ThumbRightMAX) 
		thumbRight.attach(manipulatorRight,thumbPin)
		thumbRight.setSpeed(1)
		thumbRight.setRest(ThumbRightMIN)
		# Index droit
		indexRight = Runtime.createAndStart("indexRight","Servo")
		indexRight.map(0,180,IndexRightMIN,IndexRightMAX) 
		indexRight.attach(manipulatorRight,indexPin)
		indexRight.setSpeed(1)
		indexRight.setRest(IndexRightMIN)
		# Majeur droit
		majeureRight = Runtime.createAndStart("majeureRight","Servo")
		majeureRight.map(0,180,majeureRightMIN,majeureRightMAX) 
		majeureRight.attach(manipulatorRight,majeurePin)
		majeureRight.setSpeed(1)
		majeureRight.setRest(majeureRightMIN)
		# Annulaire droit
		ringFingerRight = Runtime.createAndStart("ringFingerRight","Servo")
		ringFingerRight.map(0,180,ringFingerRightMIN,ringFingerRightMAX) 
		ringFingerRight.attach(manipulatorRight,ringFingerPin)
		ringFingerRight.setSpeed(1)
		ringFingerRight.setRest(ringFingerRightMIN)
		# Auriculaire droit
		pinkyRight = Runtime.createAndStart("pinkyRight","Servo")
		pinkyRight.map(0,180,pinkyRightMIN,pinkyRightMAX) 
		pinkyRight.attach(manipulatorRight,pinkyPin)
		pinkyRight.setSpeed(1)
		pinkyRight.setRest(pinkyRightMIN)
		# Poignée droit
		wristRight = Runtime.createAndStart("wristRight","Servo")
		wristRight.map(0,180,WristRightMIN,WristRightMAX) 
		wristRight.attach(manipulatorRight,wristPin)
		wristRight.setSpeed(1)
		wristRight.setRest(90)
	else:
		rightHand = Runtime.create("i01.rightHand", "InMoovHand")
		######################################################################
		rightHand.thumb.map(0,180,ThumbRightMIN,ThumbRightMAX) 
		rightHand.index.map(0,180,IndexRightMIN,IndexRightMAX) 
		rightHand.majeure.map(0,180,majeureRightMIN,majeureRightMAX) 
		rightHand.ringFinger.map(0,180,ringFingerRightMIN,ringFingerRightMAX) 
		rightHand.pinky.map(0,180,pinkyRightMIN,pinkyRightMAX)
		rightHand.wrist.map(0,180,WristRightMIN,WristRightMAX)
		i01.startRightHand(rightPort)


# ##############################################################################
# Exemples
#thumbLeft.attach(manipulatorLeft,thumbPin)
#thumbLeft.attach(manipulatorLeft.getName(), thumbPin)
#thumbLeft.setRest(10)
#thumbLeft.rest()
#thumbLeft.setSpeed(0.99) # set speed to 99% of full speed
#thumbLeft.moveTo(90) 
#thumbLeft.detach()
# ##############################################################################

# ##############################################################################
def testOutput():
	# exemple gestion des entrées - sorties
	# set the pinMode of pin 10 to output (you can change the pin number if you want)
	manipulatorLeft.pinMode(10, Arduino.OUTPUT)

	# turn pin 8 on and off 10 times
	for x in range(0, 10):
		manipulatorLeft.digitalWrite(8,1)
		sleep(1) # sleep a second
		manipulatorLeft.digitalWrite(8,0)
		sleep(1) # sleep a second

# ##############################################################################
def readAnalog():
	# analog input pins - you can see input
	# on the oscope 
	# pin # = 13 + analog pin#  
	# (in this case pin 16 is analog pin 3)
	manipulatorLeft.pinMode(16,0)
	manipulatorLeft.analogReadPollingStart(16)
	sleep(2) # read the analog value of pin 3 for 2 seconds
	manipulatorLeft.pinMode(16,0)
	manipulatorLeft.analogReadPollingStop(16) # stop polling

# ##############################################################################
def handRest(side):
	if ArduinoMegas==1:
		if manipulatorLeftIsOk==1 and side=="left":
			thumbLeft.rest()
			indexLeft.rest()
			majeureLeft.rest()
			ringFingerLeft.rest()
			pinkyLeft.rest()
			wristLeft.rest()
			
		elif manipulatorLeftIsOk==0 and side=="left":
			i01.leftHand.rest()
			
		elif manipulatorRightIsOk==1 and side=="right":
			thumbRight.rest()
			indexRight.rest()
			majeureRight.rest()
			ringFingerRight.rest()
			pinkyRight.rest()
			wristRight.rest()
			
		elif manipulatorRightIsOk==0 and side=="right":
			i01.rightHand.rest()

# ##############################################################################
def handDetach(side):
	if ArduinoMegas==1:
		if manipulatorLeftIsOk==1 and side=="left":
			thumbLeft.detach()
			indexLeft.detach()
			majeureLeft.detach()
			ringFingerLeft.detach()
			pinkyLeft.detach()
			wristLeft.detach()
			
		elif manipulatorLeftIsOk==0 and side=="left":
			i01.leftHand.detach()
			
		elif manipulatorRightIsOk==1 and side=="right":
			thumbRight.detach()
			indexRight.detach()
			majeureRight.detach()
			ringFingerRight.detach()
			pinkyRight.detach()
			wristRight.detach()
			
		elif manipulatorRightIsOk==0 and side=="right":
			i01.rightHand.detach()

# ##############################################################################
def moveHand(side,thumb,index,majeure,ringFinger,pinky,wrist=90):
	if ArduinoMegas==1:
		if manipulatorLeftIsOk==1 and side=="left":
			if thumb != -1:
				thumbLeft.attach(manipulatorLeft,thumbPin)
				thumbLeft.moveTo(thumb)
				
			if index != -1:
				indexLeft.attach(manipulatorLeft,indexPin)
				indexLeft.moveTo(index)
				
			if majeure != -1:
				majeureLeft.attach(manipulatorLeft,majeurePin)
				majeureLeft.moveTo(majeure)
				
			if ringFinger != -1:
				ringFingerLeft.attach(manipulatorLeft,ringFingerPin)
				ringFingerLeft.moveTo(ringFinger)
				
			if pinky != -1:
				pinkyLeft.attach(manipulatorLeft,pinkyPin)
				pinkyLeft.moveTo(pinky)

			if wrist != -1:
				wristLeft.attach(manipulatorLeft,wristPin)
				wristLeft.moveTo(wrist)
			
		elif manipulatorLeftIsOk==0 and side=="left":
			if thumb != -1:
				i01.leftHand.thumb.attach()
				i01.leftHand.thumb.moveTo(thumb)
				
			if index != -1:
				i01.leftHand.index.attach()
				i01.leftHand.index.moveTo(index)
				
			if majeure != -1:
				i01.leftHand.majeure.attach()
				i01.leftHand.majeure.moveTo(majeure)
				
			if ringFinger != -1:
				i01.leftHand.ringFinger.attach()
				i01.leftHand.ringFinger.moveTo(ringFinger)
				
			if pinky != -1:
				i01.leftHand.pinky.attach()
				i01.leftHand.pinky.moveTo(pinky)

			if wrist != -1:
				i01.leftHand.wrist.attach()
				i01.leftHand.wrist.moveTo(wrist)
			
		elif manipulatorRightIsOk==1 and side=="right":
			if thumb != -1:
				thumbRight.attach(manipulatorRight,thumbPin)
				thumbRight.moveTo(thumb)
				
			if index != -1:
				indexRight.attach(manipulatorRight,indexPin)
				indexRight.moveTo(index)
				
			if majeure != -1:
				majeureRight.attach(manipulatorRight,majeurePin)
				majeureRight.moveTo(majeure)
				
			if ringFinger != -1:
				ringFingerRight.attach(manipulatorRight,ringFingerPin)
				ringFingerRight.moveTo(ringFinger)
				
			if pinky != -1:
				pinkyRight.attach(manipulatorRight,pinkyPin)
				pinkyRight.moveTo(pinky)

			if wrist != -1:
				wristRight.attach(manipulatorRight,wristPin)
				wristRight.moveTo(wrist)

		elif manipulatorRightIsOk==0 and side=="right":
			if thumb != -1:
				i01.rightHand.thumb.attach()
				i01.rightHand.thumb.moveTo(thumb)
				
			if index != -1:
				i01.rightHand.index.attach()
				i01.rightHand.index.moveTo(index)
				
			if majeure != -1:
				i01.rightHand.majeure.attach()
				i01.rightHand.majeure.moveTo(majeure)
				
			if ringFinger != -1:
				i01.rightHand.ringFinger.attach()
				i01.rightHand.ringFinger.moveTo(ringFinger)
				
			if pinky != -1:
				i01.rightHand.pinky.attach()
				i01.rightHand.pinky.moveTo(pinky)

			if wrist != -1:
				i01.rightHand.wrist.attach()
				i01.rightHand.wrist.moveTo(wrist)
				
		sleep(2)
		handDetach(side)

# ##############################################################################
def setHandSpeed(side,thumb,index,majeure,ringFinger,pinky,wrist):
	if ArduinoMegas==1:
		if manipulatorLeftIsOk==1 and side=="left":
			if thumb != -1:
				thumbLeft.setSpeed(thumb)
			if index != -1:
				indexLeft.setSpeed(index)
			if majeure != -1:
				majeureLeft.setSpeed(majeure)
			if ringFinger != -1:
				ringFingerLeft.setSpeed(ringFinger)
			if pinky != -1:
				pinkyLeft.setSpeed(pinky)
			if wrist != -1:
				wristLeft.setSpeed(wrist)
				
		elif manipulatorLeftIsOk==0 and side=="left":
			i01.setHandSpeed("left",thumb,index,majeure,ringFinger,pinky,wrist)
			
		elif manipulatorRightIsOk==1 and side=="right":
			if thumb != -1:
				thumbRight.setSpeed(thumb)
			if index != -1:
				indexRight.setSpeed(index)
			if majeure != -1:
				majeureRight.setSpeed(majeure)
			if ringFinger != -1:
				ringFingerRight.setSpeed(ringFinger)
			if pinky != -1:
				pinkyRight.setSpeed(pinky)
			if wrist != -1:
				wristRight.setSpeed(wrist)
				
		elif manipulatorRightIsOk==0 and side=="right":
			i01.setHandSpeed("right",thumb,index,majeure,ringFinger,pinky,wrist)

# ##############################################################################
def handOpen():
	moveHand("left",ThumbLeftMIN,IndexLeftMIN,majeureLeftMIN,ringFingerLeftMIN,pinkyLeftMIN)
	moveHand("right",ThumbRightMIN,IndexRightMIN,majeureRightMIN,ringFingerRightMIN,pinkyRightMIN)

# ##############################################################################
def handClose():
	moveHand("left",ThumbLeftMAX,IndexLeftMAX,majeureLeftMAX,ringFingerLeftMAX,pinkyLeftMAX)
	moveHand("right",ThumbRightMAX,IndexRightMAX,majeureRightMAX,ringFingerRightMAX,pinkyRightMAX)
 
# ##############################################################################
def openLeftHand():
	moveHand("left",ThumbLeftMIN,IndexLeftMIN,majeureLeftMIN,ringFingerLeftMIN,pinkyLeftMIN)

# ##############################################################################
def openRightHand():
	moveHand("right",ThumbRightMIN,IndexRightMIN,majeureRightMIN,ringFingerRightMIN,pinkyRightMIN)

# ##############################################################################
def closeLeftHand():
	moveHand("left",ThumbLeftMAX,IndexLeftMAX,majeureLeftMAX,ringFingerLeftMAX,pinkyLeftMAX)
 
# ##############################################################################
def closeRightHand():
	moveHand("right",ThumbRightMAX,IndexRightMAX,majeureRightMAX,ringFingerRightMAX,pinkyRightMAX)



