# -- coding: utf-8 --
# ##############################################################################

# Configuration
megaBoardPort="COM9"
#megaBoardPort="COM8"
BoardTypeMegaBoard="atmega2560"
MegaPortIsConnected=False
ForceArduinoIsConnected=0

# ##############################################################################
# Function to check arduino & mrlcomm
# ##############################################################################
def CheckArduinos(Card,Port,slave=0):
	#A RX/TX connection don't return 'arduino is connected', only mrlcomm version
	if slave!=0:
		Card.connect(slave,Port)
		sleep(1)
	else:
		Card.connect(Port)
		sleep(1)
		for i in range(0,10):
			if not Card.isConnected():
				Card.disconnect()
				sleep(0.1)
				Card.connect(Port)
				sleep(0.5)
			else:
				break
		
	if ForceArduinoIsConnected:return True
	else:
		if not Card.isConnected() and slave==0:
			errorSpokenFunc('ArduinoNotConnected',Port)
			return False
		if Card.isConnected() or slave!=0:
			print "Mrlcomm version : ",Card.getBoardInfo().version," ( requiered ",MRLCOMM_VERSION," )"
			if Card.getBoardInfo().version!=MRLCOMM_VERSION:errorSpokenFunc('BadMrlcommVersion',Port)
			else:
				print "Arduino ",Port," OK"
				return True

# ##############################################################################
# Mega board arduino configuration
# ##############################################################################
if megaBoardIsOK==1:
	MegaBoard = Runtime.createAndStart("MegaBoard","Arduino")
	MegaBoard.setBoard(BoardTypeMegaBoard)
	MegaPortIsConnected=CheckArduinos(MegaBoard,megaBoardPort)

	#MegaBoard.connect(megaBoardPort)
	#sleep(0.5)
	MegaBoard.addListener("publishCustomMsg","python","receiveMegaData")

# ##############################################################################
# Fonction de réception de données
# ##############################################################################
def receiveMegaData(data):
	print "Mega data: ", data
	
# ##############################################################################
if megaBoardIsOK==1:

	# ############################################################################
	# Head
	# ############################################################################

	eyeX = Runtime.createAndStart("eyeX","Servo")
	eyeX.map(0,180,EyeXMIN,EyeXMAX)
	eyeX.attach(MegaBoard,EyeXPin)
	eyeX.setSpeed(EyesSpeed)
	eyeX.setRest(EyeXRest)

	eyeY = Runtime.createAndStart("eyeY","Servo")
	eyeY.map(0,180,EyeYMIN,EyeYMAX)
	eyeY.attach(MegaBoard,EyeYPin)
	eyeY.setSpeed(EyesSpeed)
	eyeY.setRest(EyeYRest)

	neck = Runtime.createAndStart("neck","Servo")
	if NeckInverted==1: 
		neck.map(0,180,MaxNeck,MinNeck)
	else:
		neck.map(0,180,MinNeck,MaxNeck)
	neck.attach(MegaBoard,NeckPin)
	neck.setSpeed(NeckSpeed)
	neck.setRest(NeckRest)

	rothead = Runtime.createAndStart("rothead","Servo")
	if RotHeadInverted==1: 
		rothead.map(0,180,MaxRotHead,MinRotHead)
	else:
		rothead.map(0,180,MinRotHead,MaxRotHead)
	rothead.attach(MegaBoard,RotHeadPin)
	rothead.setSpeed(RotHeadSpeed)
	rothead.setRest(RotHeadRest)

  # gestion des mouvement latéraux de la tete
	HeadSide = Runtime.createAndStart("HeadSide","Servo")
	HeadSide.map(0,180,MinHeadSide,MaxHeadSide)
	HeadSide.attach(MegaBoard,HeadSidePin)
	HeadSide.setSpeed(HeadSideSpeed)
	HeadSide.setRest(HeadSideRest)

	# ############################################################################
	# Left arm
	# ############################################################################

	leftArmBicep = Runtime.createAndStart("leftArmBicep","Servo")
	leftArmBicep.map(0,180,BicepsLeftMIN,BicepsLeftMAX)
	leftArmBicep.attach(MegaBoard,BicepsLeftPin)
	leftArmBicep.setSpeed(1)
	leftArmBicep.setRest(0)
		
	leftArmRotate = Runtime.createAndStart("leftArmRotate","Servo")
	leftArmRotate.map(0,180,RotateLeftMIN,RotateLeftMAX)
	leftArmRotate.attach(MegaBoard,RotateLeftPin)
	leftArmRotate.setSpeed(1)
	leftArmRotate.setRest(90)

	leftArmShoulder = Runtime.createAndStart("leftArmShoulder","Servo")
	leftArmShoulder.map(0,180,ShoulderLeftMIN,ShoulderLeftMAX)
	leftArmShoulder.attach(MegaBoard,ShoulderLeftPin)
	leftArmShoulder.setSpeed(1)
	leftArmShoulder.setRest(10)
		
	leftArmOmoplate = Runtime.createAndStart("leftArmOmoplate","Servo")
	leftArmOmoplate.map(0,180,OmoplateLeftMIN,OmoplateLeftMAX)
	leftArmOmoplate.attach(MegaBoard,OmoplateLeftPin)
	leftArmOmoplate.setSpeed(1)
	leftArmOmoplate.setRest(0)

