# -*- coding: utf-8 -*- 

# ##############################################################################
def enableBotForAction():
	global RobotReadyForAction
	
	print "Robot is ready for action"
	RobotReadyForAction=1
	NeoPixelColor("vert")

# ##############################################################################
def disableBotForAction():
	global RobotReadyForAction
	
	print "Robot is in autonome mode"
	RobotReadyForAction=0
	NeoPixelColor("bleu_bl")

# ##############################################################################
def initialPosition():
	if ArduinoMegas==1:	
		# Pwn activation all servos
		i01.attach()
		HeadSide.attach()
		
		# Vitesse moteurs
		head.neck.setSpeed(NeckSpeed)
		head.rothead.setSpeed(RotHeadSpeed)
		HeadSide.setSpeed(HeadSideSpeed)
		setHandSpeed("left", 1.0, 1.0, 1.0, 1.0, 1.0, 1.0)
		setHandSpeed("right", 1.0, 1.0, 1.0, 1.0, 1.0, 1.0)
		i01.setArmSpeed("left", 1.0, 1.0, 1.0, 1.0)
		i01.setArmSpeed("right", 1.0, 1.0, 1.0, 1.0)
		i01.setTorsoSpeed(1.0, 1.0, 1.0)
		
		# Position defaut
		eyesfront()
		head.rothead.moveTo(RotHeadRest)
		head.rest()
		handRest("left")
		handRest("right")
		leftArm.rest()
		rightArm.rest()
		torso.rest()
		HeadSide.moveTo(HeadSideRest)
		# Wait before detach
		sleep(5)

		handDetach("left")
		handDetach("right")
		leftArm.detach()
		rightArm.detach()
		torso.detach()
		HeadSide.detach()
		#i01.head.attach()
	elif megaBoardIsOK==1:	
		eyeX.attach()
		eyeY.attach()
		HeadSide.attach()
		leftArmBicep.attach()
		leftArmRotate.attach()
		leftArmShoulder.attach()
		leftArmOmoplate.attach()

		eyeX.rest()
		eyeY.rest()
		neck.rest()
		rothead.rest()
		HeadSide.rest()

		leftArmBicep.rest()
		leftArmRotate.rest()
		leftArmShoulder.rest()
		leftArmOmoplate.rest()

		# Wait before detach
		sleep(5)

		eyeX.detach()
		eyeY.detach()
		HeadSide.detach()

		leftArmBicep.detach()
		leftArmRotate.detach()
		leftArmShoulder.detach()
		leftArmOmoplate.detach()

# ##############################################################################
def fullspeed():
	if ArduinoMegas==1:	
		setHandSpeed("left", 1.0, 1.0, 1.0, 1.0, 1.0, 1.0)
		setHandSpeed("right", 1.0, 1.0, 1.0, 1.0, 1.0, 1.0)
		i01.setArmSpeed("left", 1.0, 1.0, 1.0, 1.0)
		i01.setArmSpeed("right", 1.0, 1.0, 1.0, 1.0)
		i01.setHeadSpeed(1.0, 1.0)
		i01.setTorsoSpeed(1.0, 1.0, 1.0)

# ##############################################################################
def relax():
	if ArduinoMegas==1:	
		setHandSpeed("left", 0.85, 0.85, 0.85, 0.85, 0.85, 0.85)
		setHandSpeed("right", 0.85, 0.85, 0.85, 0.85, 0.85, 0.85)
		i01.setArmSpeed("right", 0.75, 0.85, 0.65, 0.85)
		i01.setArmSpeed("left", 0.95, 0.65, 0.75, 0.75)
		i01.setHeadSpeed(0.85, 0.85)
		i01.setTorsoSpeed(0.75, 0.55, 1.0)
		i01.moveHead(79,100)
		i01.moveArm("left",5,84,28,14)
		i01.moveArm("right",5,82,28,16)
		moveHand("left",92,33,37,71,66,25)
		moveHand("right",81,66,82,60,105,113)
		i01.moveTorso(95,90,90)
	
# ##############################################################################
def ShutDown():
	global MoveHeadRandom
	MoveHeadRandom=0
	
	if RobotReadyForAction==1:
		# Commande OK
		NeoPixelPulseAnimation(1)
		# Stop tous les timers
		stopAllTimer()
		talkBlocking("Extinction, je vais dormir.")
		ear.stopListening()
		# Mise en sommeil Activator
		shudownRequest()
		# Mets InMoov en position initiale
		initialPosition()
		sleep(2)
		# Program exit
		runtime.exit()

# ##############################################################################
def Presentation():
	global RobotReadyForAction
	global enableMoveHeadRandom
	
	enableMoveHeadRandom=1

	talk("bonjour, je mappelle jarvisse")
	sleep(5)
	talk("je vais vous présenter activator")
	sleep(4)

	# Gestion de l'alimentation
	talk("Activator gère mon alimentation et me prévient si une de mes batteries devient faiblarde")
	sleep(8)

	# Volume
	enableMoveHeadRandom=1
	talk("Activator gère aussi le niveau sonore de ma voix")
	sleep(6)
	SoundControl(45)
	talk("Je peux donc parler trés fort")
	sleep(8)
	SoundControl(20)
	talk("et je peux aussi parler tout doucement")
	sleep(8)
	SoundControl(28)
	talk("maintenant, je parle normalement")
	sleep(8)
	
	# Ring
	enableMoveHeadRandom=1
	talk("Activator gère mon ring qui permet de partager mes émotions. Il clignote aussi au rythme du son de ma voix")
	sleep(10)
	NeoPixelPulseAnimation(1)
	talk("et peux faire différentes animations")
	sleep(8)
	NeoPixelPulseAnimation(2)
	sleep(8)

	# gestion de la bouche
	enableMoveHeadRandom=1
	JawBlock()
	sleep(0.1)
	talk("Je peux bloquer ma bouche pour écouter de la musique par exemple")
	sleep(5)
	RobotReadyForAction=1
	JawAction("ouvre")
	talk("je peux ouvrir la bouche pour inspection")
	sleep(5)
	JawAction("ferme")
	talk("et fermer")
	sleep(5)
	JawDeBlock()
	RobotReadyForAction=0

	# Watchdog
	enableMoveHeadRandom=1
	talk("Activator surveille aussi si mon cerveau fonctionne, et si quelques choses ne va pas, alors activator redémarre mon système")
	sleep(10)

	talk("Voilà j'ai terminé ma présentation")
	sleep(5)
	talk("Je vous souhaite mes meilleux voeux pour deux mille dix sept")
	sleep(10)
	
	initialPosition()

	