# ##############################################################################
#
# ##############################################################################

# ##############################################################################
# Désactive le fichier log
# ##############################################################################
#from org.myrobotlab.logging import LoggingFactory
#from org.myrobotlab.logging import LoggingSLF4J
 
#log = LoggingFactory().getInstance()
#log.removeAllAppenders()

# ##############################################################################
# Version logiciel
# ##############################################################################
version='1.5.0'

# ##############################################################################
# Variables globales
# ##############################################################################
Ispeak=0
enableRandom=0
RobotIsStarted=0
MoveEyesRandom=1
TuTeTais=0
enablePresentation=0
enableMoveHeadRandom=1

megaBoardIsOK=1

MRLCOMM_VERSION=55

# Voix emotions
laugh = [" #LAUGH01# ", " #LAUGH02# ", " #LAUGH03# ", " ", " "]
troat = [" #THROAT01# ", " #THROAT02# ", " #THROAT03# ", " ", " ", " "]

# ##############################################################################
# Librairies Pythons
# ##############################################################################
import urllib2

from java.lang import String
import random
import threading
import io
import itertools
import random
import time
import textwrap
import codecs
import socket
import os
import shutil
import hashlib
import subprocess
import json
import time
import csv
import sys
#import feedparser
import re
from time import sleep
from datetime import datetime
from subprocess import Popen, PIPE
from org.myrobotlab.service import Servo

# ##############################################################################
# Répertoire de travail
# ##############################################################################
oridir="D:/Jarvis/"

# ##############################################################################
# Vérification de la présence des fichiers de configuration
# ##############################################################################
if os.path.isfile(oridir + 'CONFIG/Config.py'):
	print("config file ok")
else:
	shutil.copyfile(oridir + 'CONFIG/Config.py.default',oridir + 'CONFIG/Config.py')
	
if os.path.isfile(oridir + 'CONFIG/ServoParam.py'):
	print("servo file ok")
else:
	shutil.copyfile(oridir + 'CONFIG/ServoParam.py.default',oridir + 'CONFIG/ServoParam.py')

# ##############################################################################
# Chargement des paramètres de config
# ##############################################################################
# -- coding: utf-8 --
execfile(oridir + 'CONFIG/Config.py')
execfile(oridir + 'CONFIG/ServoParam.py')

print myBotname, " version: ",version

# ##############################################################################
# Fix programab aimlif problems : remove all aimlif files
# ##############################################################################
try:
	shutil.rmtree(oridir + 'ProgramAB/bots/ai/aimlif')
except: 
	pass

# ##############################################################################
# Service Chat bot
# ##############################################################################
chatBot = Runtime.createAndStart("chatBot", "ProgramAB")

# ##############################################################################
# Service filtre des messages Html
# ##############################################################################
htmlFilter = Runtime.createAndStart("htmlfilter", "HtmlFilter")

# ##############################################################################
# Service parole
# ##############################################################################
mouth = Runtime.createAndStart("Mouth", "NaturalReaderSpeech")
#mouth = Runtime.createAndStart("i01.mouth", "MarySpeech")

mouth.setLanguage("FR")
mouth.setVoice(Voice)

# ##############################################################################
# Service d'écoute
# ##############################################################################
def heard(data):
  print "Speech Recognition Data:"+str(data)

ear = Runtime.createAndStart("Ear", "WebkitSpeechRecognition")
ear.addMouth(mouth)
ear.setLanguage("fr-FR")
python.subscribe(ear.getName(),"recognized")

# ##############################################################################
# MRL Routing webkitspeechrecognition/ear -> program ab -> htmlfilter -> mouth
# ##############################################################################
chatBot.setPath(oridir + 'ProgramAB/')
chatBot.startSession("default", "ai")
chatBot.addTextListener(htmlFilter)

htmlFilter.addListener("publishText", python.name, "talk") 

python.subscribe(mouth.getName(),"publishStartSpeaking")
python.subscribe(mouth.getName(),"publishEndSpeaking")

# ##############################################################################
#	Permet d'avoir le niveau de la batterie du PC sur lequel MRL tourne
# a ne pas confondre avec les batteries d'alimentation des modules et servos 
# ##############################################################################
level = Runtime.getBatteryLevel()
print "Niveau de batterie du PC: ",level, "%"

# ##############################################################################
# Open cv + lattepanda tweak
# ##############################################################################
opencv = Runtime.create("OpenCv", "OpenCV")
if HD3000CAM==1:
	opencv.setFrameGrabberType("org.myrobotlab.opencv.SarxosFrameGrabber")
opencv = Runtime.start("OpenCv", "OpenCV")
opencv.setCameraIndex(0)

python.subscribe(opencv.getName(),"publishOpenCVData")

# ##############################################################################
# Service WebGui
# ##############################################################################
webgui = Runtime.create("WebGui","WebGui")

# ##############################################################################
# Service Python
# ##############################################################################
python = Runtime.start("python","Python")

# ##############################################################################
# Initialisation hardware
# ##############################################################################
if megaBoardIsOK==1:
	execfile(oridir + 'HARDWARE/MegaBoard.py')
else:
	execfile(oridir + 'HARDWARE/InMoov.py')

execfile(oridir + 'HARDWARE/Activator2.py')
execfile(oridir + 'HARDWARE/Manipulator.py')
#execfile(oridir + 'HARDWARE/Tractor.py')
	
# ##############################################################################
# Chargement des fichiers gestures
# ##############################################################################
execfile(oridir + 'GESTURES/Head.py')
execfile(oridir + 'GESTURES/Arm.py')
execfile(oridir + 'GESTURES/Divers.py')

# ##############################################################################
# Modules pythons
# ##############################################################################
execfile(oridir + 'PYTHON/System.py')

execfile(oridir + 'PYTHON/SpeakListen.py')
execfile(oridir + 'PYTHON/Timers.py')

execfile(oridir + 'PYTHON/OpenCv2.py')
execfile(oridir + 'PYTHON/Anniversaire.py')
execfile(oridir + 'PYTHON/Domotique.py')
execfile(oridir + 'PYTHON/Meteo.py')

execfile(oridir + 'PYTHON/Functions.py')
execfile(oridir + 'PYTHON/WikiData.py')
#execfile(oridir + 'PYTHON/Traduction.py')
execfile(oridir + 'PYTHON/News.py')

# ##############################################################################
# PID pour tracking
# ##############################################################################
pidX = Runtime.createAndStart("pidX","Pid")
pidX.setPID("x",0.1, 0, 0.1)
pidX.setMode("x",1)
pidX.setOutputRange("x",-2, 2)
pidX.setControllerDirection("x",0)
pidX.setSetpoint("x",70)

pidY = Runtime.createAndStart("pidY","Pid")
pidY.setPID("y",0.1, 0, 0.1)
pidY.setMode("y",1)
pidY.setOutputRange("y",-2, 2)
pidY.setControllerDirection("y",0)
pidY.setSetpoint("y",70)

# ##############################################################################
# Servos power ON
# ##############################################################################
powerServoON()
sleep(1)

# ##############################################################################
# on met le robot dans sa position repos puis les servos ne sont plus solicités
# ##############################################################################
initialPosition()

# ##############################################################################
# Le système est prêt, on le renseigne à Activator.
# ##############################################################################
pcIsReady()
NeoPixelPulseTime(4)
NeoPixelPulseAnimation(2)

######################################################################
# Launch the web gui and create the webkit speech recognition gui
# This service works in Google Chrome only with the WebGui
#################################################################
webgui.autoStartBrowser(False)
webgui.startService()
sleep(1)
webgui.startBrowser("http://localhost:8888/#/service/Ear")

# ##############################################################################
# Robot is ready
# ##############################################################################
startAllTimer()
sleep(0.5)
NeoPixelColor("bleu_bl")
SoundControl(28)
chatBot.getResponse("WAKE_UP")
RobotIsStarted=1

# ##############################################################################
# Vérifie s'il y a un anniversaire
# ##############################################################################
anniversaire("0")

# ##############################################################################
# Test
# ##############################################################################
#Presentation()
enableMoveHeadRandom=1

#initOpenCV()








